from __future__ import print_function
# -*- coding: utf-8 -*-

import math
import numpy as np
from math import cos,sin,pi
import time
import random
import wave
from scipy import fftpack
import re
"""
from multiprocessing import Process, Queue, current_process, freeze_support
def worker(input, output):
	for func, args in iter(input.get, 'STOP'):
		result = calculate(func, args)
		output.put(result)
def calculate(func, args):
	result = func(*args)
	return result
"""	
class br_wave(object):
	def __init__(self,_NomFich='guitare.wav'):
		self.fich=_NomFich

	def GetParams(self): # (1, 2, 44100, 260160, 'NONE', 'not compressed')
		f=wave.open(self.fich,'r')
		self._params=f.getparams()
		f.close()
		print(self._params)
		
		print(['1 canal','2 canaux'][self._params[0]])
		print( ['','8 bits / canal','16 bits / canal'][self._params[1]] )
		
		# frequence d'echantillonnage en Hz
		self.fe=self._params[2]*1.0# 44100.0
		print("frequence d'echantillonnage : "+str(self.fe)+" Hz")
		
		self.NbDePts=self._params[3]
		print('nombre de points :'+str(self.NbDePts))
		
		self.duree=1.0*self.NbDePts/self.fe
		
		

		
	def fich2string(self):
		self.GetParams()
		f=wave.open(self.fich,'r')				
		self.String=f.readframes(self.NbDePts)
		f.close()

		
	def S16b2Valeur(self,B16):# B16 = [ 0..255 , 0..255]
		faible,fort = B16
		def num(nb):#-128 a 127
			return ( (nb<=127)*nb+(nb>127)*(nb-256) )
		return (num(fort)*256+faible	)/32768.0

	def S8b2Valeur(self,B8):# B8 = 0..255
		def num(nb):#-128 a 127
			return ( (nb<=127)*nb+(nb>127)*(nb-256) )
		return num(B8)/128.0
		
	def Valeur2S16b(self,nb):# -1.0 a 1.0 
		if nb>=0:
			fort=int(nb * 128.0) #40
			faible=int( (nb-fort/128.0)*32768.0 )
		else:
			fort=-int(-(nb*128.0+256)) #250
			faible=int( ( nb -(fort-256)/128.0   )*32768.0)
		return [faible,fort]

	def Valeur2S8b(self,V):# -1.0 a 1.0 
		return int( 128.0*V*(V>=0) + (128.0*V+256.0)*(V<0) ) 
		
	def S16b2Xn(self):
		"""
		for i in range(0,2*self.NbDePts,2):
			print ( i ,  self.S16b2Valeur( [ ord(self.String[i]) , ord(self.String[i+1]) ] )  )
		"""	
		X=[self.S16b2Valeur( [ ord(self.String[i]) , ord(self.String[i+1]) ] ) for i in range(0,2*self.NbDePts,2) ]
		self.X=np.array(list(X), dtype=np.float64)

	def S8b2Xn(self):
		X=[self.S8b2Valeur(ord(self.String[i])) for i in range(self.NbDePts)]		
		self.X=np.array(list(X), dtype=np.float64)

	def Xn2Fq(self,seuil=0.0):
		seuil2=seuil**2.0
		son=self.X
		N=len(son)
		fourier = fftpack.fft(son)/np.size(son)
		resultat=np.fft.fftshift(fourier)+0j
		
		
		Resultats=[ [ resultat[i] , (0.0+i-N/2.0)*self.fe/N ] for i in range(N) if np.real(resultat[i])>seuil ]
		self.TF=Resultats
		self.TFSort=sorted(self.TF, key=lambda tabl: tabl[0] )
		print('nombres de frequences selectionnees : '+str(len(self.TFSort)))
		
	def Fq2Fich(self):
		f=open(re.sub("\.([a-zA-Z0-9]*)$",".fqs",self.fich),'w')
		for a,fq in self.TFSort:
			print(str(a)+';'+str(fq),file=f)
		f.close()
	
	def FichFqs2TFSort(self,fich='guitare.fqs',seuil=0.0):
		seuil2=seuil**2.0
		f=open(fich,'r')
		self.TFSort=[]
		for line in f:
			an,fn=line.split(';')
			an,fn=np.complex(an),float(fn)
			if (an * an.conjugate()).real > seuil2 :
				self.TFSort.append([an,fn])
		print('nombres de frequences selectionnees : '+str(len(self.TFSort)))		
	
	
	def Fqs2Xn(self):
		print('temps estime :'+str(1.80E-7*self.NbDePts*len(self.TFSort)))
		t=time.time()
		
		'''
		fqs=[ fq[1] for fq in self.TFSort ]
		fqs.sort()
		fqs=np.array(list(fqs), dtype=np.float64)		
		N=len(fqs)
		fourier = fftpack.fft(fqs)/np.size(fqs)
		resultat=np.fft.fftshift(fourier)+0j
		'''
		tt = np.arange(0.0,0.0+self.NbDePts, dtype=np.float64)/self.fe
		valeurs=np.array(0.0*tt)+0j
		for res in self.TFSort:
			valeurs+=res[0]   *np.cos(res[1]*2*pi*tt)+0j
			valeurs+=res[0]*1j*np.sin(res[1]*2*pi*tt)+0j
		self.X=valeurs	
		print('temps de Fqs2Xn ',time.time()-t ,(time.time()-t)/self.NbDePts)
			
	
	def	Xn2Wav(self,data=''):
		if data=='':
			data=self.X
		g=wave.open(self.fich+'.wav','w')
		g.setparams(tuple(self._params))#g.setparams((1, 2, 44100, 1800000, 'NONE', 'not compressed'))
		s=''
		for valeur in data:
			faible,fort=self.Valeur2S16b(np.real(valeur))
			s+=chr(faible)+chr(fort)
		g.writeframesraw(s)
		g.close()
		
		
		

"""
son=br_wave('guitare.wav')
son.fich2string()
son.S16b2Xn()
son.Xn2Fq()
son.Fq2Fich()

print(son.TFSort[0:5])
"""

"""
son=br_wave('guitare.wav')
son.GetParams()
son.FichFqs2TFSort('guitare.fqs',0.0005)
son.Fqs2Xn()
"""

son=br_wave('guitare.wav')
son.GetParams()
son.fich2string()
son.S16b2Xn()
son.Xn2Fq()
son.Fqs2Xn()
son.Xn2Wav()

'''



global Calculs



tt = np.arange(0.0,0.0+N, dtype=np.float64)/fe

		



t=time.time()
print('temps estimé : intervalle = ',intervalle ,' N = ',N )

"""
X : [] : x(n) in [-1;1]
_valeurs : np.array : x(n) in [-1;1]
_carres : np.array : ( x(n) )**2 in [0;1] 




_resultat : np.array :  0.0
_Resultats : [] : [(0.0+i-intervalle/2)*fe/intervalle,0.0]
"""

_resultat=np.array(list([0.0 for i in range(N)]), dtype=np.float64)

#_frequences_du_bruit=np.array(list([[(0.0+i-N/2)*fe/N,1.0] for i in range(N)]), dtype=np.float64)
_frequences_du_bruit=[]

resultats=[[(0.0+i-intervalle/2)*fe/intervalle,0.0] for i in range(intervalle)]
aa,bb=0.0,0
for k in range(0,N-intervalle,intervalle):
	moy=np.mean(_carres[k:k+intervalle], dtype=np.float64)
	if moy>seuil:
		for m in range(k,k+intervalle):
			_resultat[m]=X[m]		
		N=intervalle
		# Array temporel :
		#tt = np.arange(1.-N/2,N-N/2+1, dtype=np.float64)/fe
		tt = np.arange(0.0,0.0+N, dtype=np.float64)/fe
		
		bruit=[S16b2Valeur([ord(s[k+i]),ord(s[k+i+1])]) for i in range(0,2*N,2)]
		bruit=np.array(list(bruit))+0j
		fourier = fftpack.fft(bruit)/np.size(bruit)
		resultat=np.fft.fftshift(fourier)+0j (  )
		Resultats=[[(0.0+i-N/2)*fe/N,resultat[i]] for i in range(len(resultat))]
		for fq in [res[0] for res in Resultats if res[1]<1.1]:
			_frequences_du_bruit.append(fq)
		#print(Resultats[0])
		aa+=Resultats[0][1]
		bb+=1.0
		
print(aa/bb)
		
#print(type(sinux),sinux)
print('#################### '+str(N)+' ############################')


temps=time.time()-t
print('temps réel : ' , temps)#print( 'temps**0.5 / N : ',(temps)**(0.5) / N  )


from matplotlib import pyplot as plt


g=wave.open('moyenne-riff-'+str((intervalle)).zfill(5)+'.wav','w')
_params=[_params[i] for i in range(len(_params))]
_params[3]=N
g.setparams(tuple(_params))#g.setparams((1, 2, 44100, 18, 'NONE', 'not compressed'))

s=''
for valeur in _resultat:
	faible,fort=Valeur2S16b(np.real(valeur))
	s+=chr(faible)+chr(fort)
g.writeframesraw(s)
g.close()
print('nb de valeurs '+str(len(_valeurs)))
print('longueur de s '+str(len(s)))









# On plot
plt.figure()
plt.subplot(121)
plt.plot(tt,_valeurs,'-')


#plt.plot(tt,sinux,'r-')
plt.xlabel('axe temporel, en seconde')
"""
# On plot
plt.figure()
plt.subplot(122)
plt.plot(tt,valeurs,'-')
plt.plot(tt,valeurs,'r-')
plt.xlabel('axe temporedddsl, en seconde')
"""
"""
# axe frequentiel:
axe_f = np.arange(0.-N/2,N-1-N/2+1)*fe/N
plt.subplot(122)
plt.plot(axe_f,np.abs(resultat),'x-')
plt.xlabel('axe frequentiels en Hertz')


"""
# axe frequentiel:
plt.figure()
plt.subplot(122)
plt.plot(tt,_resultat,'-')
plt.xlabel('difference init.tf,en seconde')


plt.show()

'''
print('fini')
